###########################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################


class EndPointReference(object):
    def __init__(self):
        self._Address = None
        self._ReferenceProperties = None
    
    def getAddress(self, value):
        return self._Address
    def setAddress(self, value):
        self._Address = value
    Address = property(getAddress, setAddress, None, 
        'local Address')

    def getReferenceProperties(self, value):
        return self._ReferenceProperties
    def setReferenceProperties(self, value):
        self._ReferenceProperties = value
    ReferenceProperties = property(getReferenceProperties, setReferenceProperties, None, 
        'local ReferenceProperties')

    def new_ReferenceProperties(self):
        return ReferenceProperties()


class ReferenceProperties(object):
    def setAny(self, value):
        self._any = value
    def getAny(self, value):
        return self._any
    Any = property(getAny, setAny, None,
        'wildcard')


class AddressingUtils:

    @staticmethod
    def createEndpointReference(ctx, pyobj=None):
        epr = pyobj or EndPointReference()
        epr.Address = ctx.getAddress()
        resourceID = ctx.getResourceID()
        if resourceID:
            epr.ReferenceProperties = refprop = epr.new_ReferenceProperties()
            refprop.Any = [resourceID]
        return epr

    @staticmethod
    def getResourceID(ps, typecode):
        '''
        typecode -- representing the ResourceID expecting in WS-Address
           Header.
        '''
        d = ps.ParseHeaderElements((typecode,))
        return d[(typecode.nspname,typecode.pname)]

