import sys, exceptions, os, optparse
from urlparse import urlunparse
from twisted.python import log
from twisted.internet import reactor
from pyGsi import proxylib
from pyGridWare.common.delegationlib import delegate_cred
from pyGridWare.utility.scripts.client import \
    GetBasicOptParser, GetPortKWArgs, SetUp


class OptionHolder: pass

def DelegateCredential(kw):

    """ Convenience method to delegate credential """

    _delEPR = delegate_cred(**kw)
    reactor.stop()
    
def main():
    ## Simple set of default options.
    options = OptionHolder()
    options.authz= None
    options.m2secureMessage= False
    options.m2crypto= True
    options.m2secureConv= None
    ## TODO: use pyGSI convenience function to retrieve this
    options.cert= '/tmp/x509up_u' + str(os.getuid())
    options.key= None
    options.wsAddressURI= 'http://schemas.xmlsoap.org/ws/2004/03/addressing'


    ## The credential delegate tool doesn't use the same command line
    ## argument as the options parser provided by pyGridWare.
    
    op = optparse.OptionParser()
    op.remove_option("-h")
    op.add_option("-h", "--host", action="store", dest="host",
        help="Hostname to contact", default="localhost")
    op.add_option("-p", "--port", action="store", dest="port",
        help="Port to contact", default="8443")
    op.add_option("-d", "--debug",
        action="store", dest="debug", default=0,
        help="Debug Messages to file, if 1 send to stdout, if 0 then off.")


    (cloptions, args) = op.parse_args()
    
    if cloptions.debug:
        log.startLogging(sys.stdout)

    options.url=urlunparse(("https", cloptions.host + ":" + cloptions.port, "/wsrf/services/" + "DelegationFactoryService", None, None, None))

    options.limited = False
    try:
        kw = GetPortKWArgs(options)
    except proxylib.InvalidProxyException:
        print "Cannot contact service with an invalid proxy"
        return -1

    ## Always do full delegation
    kw['full'] = True


    reactor.callWhenRunning(DelegateCredential, kw)
    reactor.run()

if __name__ == '__main__':
    main()
