#!/usr/bin/env python
############################################################################
# Automatically generated by wsdl2web.py
# See LBNLCopyright for copyright notice!
###########################################################################
import os
from twisted.python import log
from twisted.internet import reactor

import ZSI
from pyGridWare.utility.scripts.client import GetBasicOptParser, GetPortKWArgs, SetUp
from pyGridWare.utility.generate import wsdl2web


"""Test script for globus container SecureCounterService in default configuration.  
Grabs the wsdl by querying the service, generates code, then calls the service.  

Message Security:
  ./counter_client.py -uhttp://131.243.2.159:8080/wsrf/services/SecureCounterService 

-vhttp://131.243.2.159:8080/wsrf/services/SecureCounterService-authService

"""

def setup(options, wsdl):
    wsdl2web.run('%s?wsdl' %options.url, 
        force=True,
        config=os.path.join('config', 'server-config.txt'),
        tac=os.path.join('config', 'server-config.tac'))


def main(**kw):
    from generated.SecureCounterService.stubs import SecureCounterService as CLIENT
    locator = CLIENT.CounterServiceLocator()
    port = locator.getCounterPortTypePort(**kw)
    
    rsp = port.createCounter( CLIENT.CreateCounterRequest() )
    kw['endPointReference'] = rsp.EndpointReference

    iport = locator.getCounterPortTypePort(**kw)
    rsp = iport.Destroy( CLIENT.DestroyRequest() )

    try:
        rsp = iport.Destroy( CLIENT.DestroyRequest() )
    except Exception,ex:
        reactor.stop()
        print '------------------------------'
        print '  CounterService tests passed!!!'
        print '------------------------------'
        return

    raise RuntimeError, 'didnt receive soap:fault?'


if __name__ == '__main__':
    op = GetBasicOptParser()
    (options, args) = op.parse_args()
    options.m2secureConv = '%s-authService' %options.url

    SetUp(options)
    kw = GetPortKWArgs(options)

    reactor.callWhenRunning(setup, options, args)
    reactor.callWhenRunning(main, **kw)
    reactor.run()


