#!/usr/bin/env python
##########################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import warnings
from suites import WSRFTestCase, WSRFTestSuite
try:
    from pyGridWare.common import delegationlib as dlib
except:
    warnings.warn('delegation test suite not available because of import errors')

# DelegationFactoryService is core WSDL
WSDL = None

class DelegationTestCase(WSRFTestCase):
    path = '/wsrf/services/GSIPortalDelegationService'
    
    def tearDown(self):
        self.shouldStop = False
        
    def runTest(self):
        self.epr = dlib.delegate_cred(isFull=True, lifetime=12, **self.client_kw)
        
       

def default():
    """Create new SSL Context in order to use a different credential,
    then try to access a service resource instance created with the
    original credential and protected by ResourcePortal.

    Receives a "ResourceUnknownFault", because we can not see the
    the resource as a different user.
    """
    return WSRFTestSuite(tests=(DelegationTestCase(),))
        
       
