#!/usr/bin/env python
import unittest
from ZSI import ParsedSoap
from pyGridWare.generated.stubs.basenotification import Notify
import pyGridWare.generated.types.submanagerservice
import pyGridWare.generated.types.reliabletransferfactoryservice
import pyGridWare.generated.types.reliabletransferservice
import pyGridWare.generated.types.basefaults
import pyGridWare.generated.types.basenotification
import pyGridWare.generated.types.delegationfactoryservice
import pyGridWare.generated.types.delegationservice
import pyGridWare.generated.types.exclusivecanonicalization
import pyGridWare.generated.types.gramfactoryservice
import pyGridWare.generated.types.managedjobfactory
import pyGridWare.generated.types.managedjobservice
import pyGridWare.generated.types.notificationconsumerservice
import pyGridWare.generated.types.reliabletransferfactoryservice
import pyGridWare.generated.types.reliabletransferservice
import pyGridWare.generated.types.resourcelifetime
import pyGridWare.generated.types.resourceproperties
import pyGridWare.generated.types.secureconversation
import pyGridWare.generated.types.submanagerservice


class TestCase(unittest.TestCase):
    """Test WSRF BaseFault
    """
    def check_rft_notification(self):
        ps = ParsedSoap(XML)
        pyobj = ps.Parse(Notify.typecode)
        print pyobj.NotificationMessage
        for i in pyobj.NotificationMessage: 
            print "\t", i
            print "\t"*2, i.Message
            o = i.Message.ResourcePropertyValueChangeNotification.NewValue.Any
            print o.TransfersFinished
            print o.TransfersRestarted
            print o.TransfersFailed
            print o.TransfersActive
            print o.TransfersPending
            print o.TransfersCancelled
            print o.Fault
            error_code = o.Fault.RftTransferFaultType.ErrorCode
            print "ERRORCODE: ", error_code
            print "\tDialect: ", error_code.get_attribute_dialect()
            print "\tContents: ", error_code.Any
            print "\tMixed   : ", error_code._text
    
            desc = o.Fault.RftTransferFaultType.Description[0]
            print "Description   : ", desc
            print "\txml:lang    : ", desc.get_attribute_lang()
    

XML = """<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/03/addressing">
  <soapenv:Header>
    <wsa:MessageID soapenv:mustUnderstand="0">
    uuid:5f611600-6de8-11db-9807-aede9931d7cd</wsa:MessageID>
    <wsa:To soapenv:mustUnderstand="0">
    http://131.243.2.15:44955/wsrf/services/NotificationConsumerService</wsa:To>
    <wsa:Action soapenv:mustUnderstand="0">
    http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Notify</wsa:Action>
    <wsa:From soapenv:mustUnderstand="0">
      <wsa:Address>
      http://schemas.xmlsoap.org/ws/2004/03/addressing/role/anonymous</wsa:Address>
    </wsa:From>
    <ns4:WS-BaseNotificationKey xmlns:ns4="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.wsdl/service" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="xsd:int" soapenv:mustUnderstand="0">
    1000</ns4:WS-BaseNotificationKey>
  </soapenv:Header>
  <soapenv:Body>
    <Notify xmlns="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd">
      <NotificationMessage>
	<Topic Dialect="http://docs.oasis-open.org/wsn/2004/06/TopicExpression/Simple" xmlns:ns1="http://www.globus.org/namespaces/2004/10/rft">
	ns1:OverallStatusProperty</Topic>
	<ProducerReference>
	  <wsa:Address>
	  https://131.243.2.15:8443/wsrf/services/ReliableFileTransferService</wsa:Address>
	  <wsa:ReferenceProperties>
	    <ns2:TransferKey xmlns:ns2="http://www.globus.org/namespaces/2004/10/rft">
	    100</ns2:TransferKey>
	  </wsa:ReferenceProperties>
	  <wsa:ReferenceParameters/>
	</ProducerReference>
	<Message xsi:type="ns3:ResourcePropertyValueChangeNotificationElementType" xmlns:ns3="http://wsrf.globus.org/core/notification">
	  <ns4:ResourcePropertyValueChangeNotification xmlns:ns4="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd">
	    <ns4:NewValue>
	      <ns5:OverallStatusProperty xmlns:ns5="http://www.globus.org/namespaces/2004/10/rft">
		<ns5:transfersFinished>
		0</ns5:transfersFinished>
		<ns5:transfersRestarted>
		0</ns5:transfersRestarted>
		<ns5:transfersFailed>
		1</ns5:transfersFailed>
		<ns5:transfersActive>
		0</ns5:transfersActive>
		<ns5:transfersPending>
		0</ns5:transfersPending>
		<ns5:transfersCancelled>
		0</ns5:transfersCancelled>
		<ns5:fault>
		  <ns5:rftTransferFaultType>
		    <ns6:Timestamp xmlns:ns6="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd">2006-11-06T22:44:33Z</ns6:Timestamp>
		    <ns7:Originator xmlns:ns7="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd">
		      <wsa:Address>
		      https://131.243.2.15:8443/wsrf/services/ReliableFileTransferFactoryService</wsa:Address>
		      <wsa:ReferenceProperties>
			<ns5:TransferKey>
			100</ns5:TransferKey>
		      </wsa:ReferenceProperties>
		      <wsa:ReferenceParameters/>
		    </ns7:Originator>
		    <ns8:ErrorCode dialect="http://www.globus.org/fault/stacktrace" xmlns:ns8="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd">
		      org.globus.transfer.reliable.service.exception.RftException: Unable to connect to host: &quot;poohbah&quot; at port &quot;2811&quot;
		      at org.globus.transfer.reliable.service.TransferClient.setDestinationHost(TransferClient.java:265)
		      at org.globus.transfer.reliable.service.TransferWork.getNewClient(TransferWork.java:432)
		      at org.globus.transfer.reliable.service.TransferWork.getTransferClient(TransferWork.java:373)
		      at org.globus.transfer.reliable.service.TransferWork.run(TransferWork.java:684)
		      at org.globus.wsrf.impl.work.WorkManagerImpl$WorkWrapper.run(WorkManagerImpl.java:355)
		      at java.lang.Thread.run(Thread.java:595)
		    </ns8:ErrorCode>
		    <ns9:Description xmlns:ns9="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd">
		    Unable to connect to host: &quot;poohbah&quot; at port &quot;2811&quot;</ns9:Description>
		    <ns10:FaultCause xmlns:ns10="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd">
		      <ns10:Timestamp>2006-11-06T22:44:33Z</ns10:Timestamp>
		      <ns10:Description>
		      Unable to connect to host: &quot;poohbah&quot; at port &quot;2811&quot;</ns10:Description>
		      <ns10:FaultCause>
			<ns10:Timestamp>2006-11-06T22:44:33Z</ns10:Timestamp>
			<ns10:ErrorCode dialect="http://www.globus.org/fault/stacktrace">
			  org.globus.transfer.reliable.service.exception.RftException: Unable to connect to host: &quot;poohbah&quot; at port &quot;2811&quot;
			  at org.globus.transfer.reliable.service.TransferClient.setDestinationHost(TransferClient.java:265)
			  at org.globus.transfer.reliable.service.TransferWork.getNewClient(TransferWork.java:432)
			  at org.globus.transfer.reliable.service.TransferWork.getTransferClient(TransferWork.java:373)
			  at org.globus.transfer.reliable.service.TransferWork.run(TransferWork.java:684)
			  at org.globus.wsrf.impl.work.WorkManagerImpl$WorkWrapper.run(WorkManagerImpl.java:355)
			  at java.lang.Thread.run(Thread.java:595)
			</ns10:ErrorCode>
			<ns10:Description>
			org.globus.transfer.reliable.service.exception.RftException</ns10:Description>
		      </ns10:FaultCause>
		    </ns10:FaultCause>
		  </ns5:rftTransferFaultType>
		</ns5:fault>
	      </ns5:OverallStatusProperty>
	    </ns4:NewValue>
	  </ns4:ResourcePropertyValueChangeNotification>
	</Message>
      </NotificationMessage>
    </Notify>
  </soapenv:Body>
</soapenv:Envelope>"""


_SEP = '_'
for t in [i[0].split(_SEP) for i in filter(lambda i: callable(i[1]), TestCase.__dict__.items())]:
    test = ''
    for f in t:
        test += f
        if globals().has_key(test): test += _SEP; continue
        def _closure():
            name = test
            def _makeTestSuite():
                suite = unittest.TestSuite()
                suite.addTest(unittest.makeSuite(TestCase, name))
                return suite
            return _makeTestSuite

        globals()[test] = _closure()
        test += _SEP


makeTestSuite = check
def main():
    unittest.main(defaultTest="makeTestSuite")
if __name__ == "__main__" : main()
